<?php
/**
 * @package Module 123 Flash Chat for DatingPro2013
 * @version $Id: functions.php  2013-08-1$
 * @author Cheney
 * @copyright (C) 2001-2013 - TOPCMM SOFTWARE
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @websites http://www.123flashchat.com
 * @technical support http://www.123flashchat.com/support.html
**/
require_once("requestRemote.php");
define('CACHE_PATH', $config['site_path'].'/templates_c/');

function getFcConfig(){
    global  $dbconn, $chat_Config,$topcmm_config;
    if(!$chat_Config){
        $sql = "select * from `".$topcmm_config['123flashchat_table']."`";
        $rs = $dbconn->Execute($sql);
        if($rs->fields){
        	$result['fc_extendserver'] 		= $rs->fields[1];
        	$result['fc_server_host'] 		= $rs->fields[2];
        	$result['fc_server_port'] 		= $rs->fields[3];
            $result['fc_server_host_s'] 	= $rs->fields[4];
        	$result['fc_server_port_s'] 	= $rs->fields[5];
            $result['fc_server_host_h'] 	= $rs->fields[6];
        	$result['fc_server_port_h'] 	= $rs->fields[7];
        	$result['fc_client_loc'] 		= $rs->fields[8];
        	$result['fc_api_url'] 			= $rs->fields[9];
        	$result['fc_group'] 			= $rs->fields[10];
        	$result['fc_room'] 				= $rs->fields[11];
            $result['fc_fullscreen'] 		= $rs->fields[12];
        	$result['fc_room_list'] 		= $rs->fields[13];
        	$result['fc_user_list'] 		= $rs->fields[14];
        	$result['fc_client_width'] 		= $rs->fields[15];
        	$result['fc_client_height'] 	= $rs->fields[16];
        	$result['fc_client_lang'] 		= $rs->fields[17];
        	$result['fc_client_skin'] 		= $rs->fields[18];
        	$result['fc_servertype'] 		= $rs->fields[19];
            $result['fc_clienttype'] 		= $rs->fields[20];
        }else{
        	$result = false;
        }
        if($result){
        	$chat_Config = $result;
        }
        return $result;
    }
    return $chat_Config;
}

function checkSlash($path){
    if(substr($path,-1,1) != "/" && !empty($path)){
        $path = $path."/";
    }
    return $path;
}

function validate_client($client_loc){
    $c_own_loc = 1;
    $swf = $client_loc . 'admin_123flashchat.swf';
    if($headers = topcmmRequestRemote::requestRemote($swf,0)){
        $c_own_loc = (substr($headers, 9, 3) == '200') ? 0 : 1;
    }
    return $c_own_loc;
}

function validate_data_api($data_api){
	$da = 1;
	if(substr(topcmmRequestRemote::requestRemote($data_api,0), 9, 3) == 200){
		$da = 0;
	}
	return $da;
}

function getValid($fcSetting){
	$c_server_loc = 1;
	if($fcSetting['fc_server_host']){
		if($fcSetting['fc_server_host'] == $_SERVER['SERVER_NAME']){
			$c_own_loc = validate_client('http://'.$fcSetting['fc_server_host'].':'.$fcSetting['fc_server_port_h'].'/');
			if(!$c_own_loc){
				$c_server_loc = 0;
			}
		}
	}else{
		$c_own_loc = validate_client('http://'.$_SERVER['SERVER_NAME'].':'.$fcSetting['fc_server_port_h'].'/');
		if(!$c_own_loc){
			$c_server_loc = 0;
		}
	}
	return $c_server_loc;
}

//save data
function saveFcSettings(){
	switch ($_POST['extendserver']){
        case 0:
            $result = saveLocalSettings();
            break;
        case 1:
            $result = saveHostSettings();
            break;
        default:
			$result = saveFreeSettings();
			break;
    }
    return $result;
}

function saveLocalSettings(){
	global $lang;
	$data['fc_extendserver'] = "0";
	$data['fc_servertype'] = $_POST['servertype'];
	$client_location = $_POST['client_loc'];
	if($client_location){
		$data['fc_client_loc'] = $client_location . (substr($client_location,-1,1) != '/' ? '/' : '');
        $serverinfo = getServerHostPortLocal($data['fc_client_loc']);
        $data['fc_server_host'] = !empty($post['server_host']) ? $post['server_host'] : (empty($serverinfo['fc_server_host']) ? $_SERVER['HTTP_HOST'] : $serverinfo['fc_server_host']) ;
        $data['fc_server_host_s'] = empty($serverinfo['fc_server_host_s']) ? $_SERVER['HTTP_HOST'] : $serverinfo['fc_server_host_s'];
        $data['fc_server_host_h'] = empty($serverinfo['fc_server_host_h']) ? $_SERVER['HTTP_HOST'] : $serverinfo['fc_server_host_h'];
		
        if(!is_numeric($_POST['server_port']) || strpos($_POST['server_port'] ,".")!==false){
			$data['fc_server_port'] = empty($serverinfo['fc_server_port']) ? ( $data['fc_servertype'] == 1 ? '51212' : '51127') : $serverinfo['fc_server_port'] ;
		}else{
			$data['fc_server_port'] = $_POST['server_port'];
		}
		if(!is_numeric($_POST['server_port_h']) || strpos($_POST['server_port_h'] ,".")!==false){
			$data['fc_server_port_h'] = empty($serverinfo['fc_server_port_h']) ? ( $data['fc_servertype'] == 1 ? '31212' : '35555') : $serverinfo['fc_server_port_h'] ;
		}else{
			$data['fc_server_port_h'] = $_POST['server_port_h'];
		}
        $data['fc_server_port_s'] = empty($serverinfo['fc_server_port_s']) ? ( $data['fc_servertype'] == 1 ? '51213' : '51128') : $serverinfo['fc_server_port_s'] ;
		$data['fc_api_url'] = 'http://' . $data['fc_server_host'] . ':' . $data['fc_server_port_h'] . '/';        
	}else{
		$data['fc_server_host'] = $_SERVER['HTTP_HOST'];
        $data['fc_server_host_h'] = $data['fc_server_host_s'] = $data['fc_server_host'];
		if($data['fc_servertype']){
			$data['fc_server_port_h'] = '31212';
            $data['fc_server_port_s'] = '51213';
			$data['fc_server_port'] = '51212';
		}else{
			$data['fc_server_port_h'] = '35555';
            $data['fc_server_port_s'] = '51128';
			$data['fc_server_port'] = '51127';
		}
		$data['fc_api_url'] = 'http://' . $data['fc_server_host'] . ':' . $data['fc_server_port_h'] . '/';
		$data['fc_client_loc'] = $data['fc_api_url'];
	}
    if($data['fc_servertype'] == 1){
        $data['fc_clienttype'] = 0;
    }else{
        $data['fc_clienttype'] = $_POST['clienttype'];            
    }
	$s_own_loc = 1;
	$c_own_loc = 1;
	$da = 1;
	if($_POST['server_local']){
		$c_own_loc = validate_client($data['fc_client_loc']);
		$da = validate_data_api($data['fc_api_url'] . 'online.js');
		if($c_own_loc || $da){
			return $lang['fc']['client_location_error'];
		}
	}else{
		$c_own_loc = validate_client($data['fc_client_loc']);
		if($c_own_loc){
			return $lang['fc']['client_location_error'];
		}
	}
	$check = validate_client('http://'.parse_url($data['fc_client_loc'], PHP_URL_HOST).':'.$data['fc_server_port_h'].'/');
	if($check){
		return $lang['fc']['client_location_not_available'];
	}
	return fc_save($data);
}

function saveHostSettings(){
	global $lang;
	$data['fc_extendserver'] = "1";
	$data['fc_client_loc'] = !empty($_POST['client_loc']) ? ($_POST['client_loc'] . (substr($_POST['client_loc'],-1,1) != '/' ? '/' : '')) : '';
	if($data['fc_client_loc'] == ''){
		return $lang['fc']['client_location_empty'];
	}
    $serverinfo = getServerHostPortHost($data['fc_client_loc']);
    if($serverinfo){
        $data['fc_server_host'] = empty($serverinfo['fc_server_host']) ? parse_url($data['fc_client_loc'], PHP_URL_HOST) : $serverinfo['fc_server_host'];
		$data['fc_server_host_s'] = empty($serverinfo['fc_server_host_s']) ? '' : $serverinfo['fc_server_host_s'];
		$data['fc_server_host_h'] = empty($serverinfo['fc_server_host_h']) ? '' : $serverinfo['fc_server_host_h'];
		$data['fc_server_port'] = empty($serverinfo['fc_server_port']) ? '' : $serverinfo['fc_server_port'];
		$data['fc_server_port_h'] = empty($serverinfo['fc_server_port_h']) ? '' : $serverinfo['fc_server_port_h'];
		$data['fc_server_port_s'] = empty($serverinfo['fc_server_port_s']) ? '' : $serverinfo['fc_server_port_s'];        
    	$data['fc_api_url'] = 'http://' . $data['fc_server_host'] . '/';
    	$data['fc_group'] = substr(parse_url($data['fc_client_loc'], PHP_URL_PATH),1,-1);
        $c_own_loc = validate_client($data['fc_client_loc']);
		$da = validate_data_api($data['fc_api_url'] . 'online.js?group=' . $data['fc_group']);
		if($c_own_loc || $da){
			return $lang['fc']['client_location_error'];
		}        
    }else{
        return $lang['fc']['client_location_error'];
    }
    $data['fc_clienttype'] = $_POST['clienttype'];
	return fc_save($data);
}

function saveFreeSettings(){
	$data['fc_extendserver'] = "2";
	$data['fc_room'] = $_POST['room'] ? $_POST['room'] : 'Lobby';
	return fc_save($data);
}

function fc_save($data){
	global  $dbconn, $topcmm_config;
	$data['fc_room_list'] = $_POST['room_list'];
	$data['fc_user_list'] = $_POST['user_list'];
	$data['fc_fullscreen'] = ($_POST['fullscreen'] > 0) ? 1 : 0;
	$data['fc_client_width'] = $_POST['client_width'];
	$data['fc_client_height'] = $_POST['client_height'];
	$data['fc_client_lang'] = $_POST['client_lang'];
	$data['fc_client_skin'] = $_POST['client_skin'];
	foreach($data as $key => $value){
		$value = mysql_escape_string($value);
		$sqlStr .= "`$key` = '$value', ";
	}
	$sqlStr = substr($sqlStr,0,-2);
	$sql = "UPDATE `".$topcmm_config['123flashchat_table']."` SET ".$sqlStr;
    $dbconn->Execute($sql);
    return true;
}

function getFcStatus($cfg){
	$data = topcmmRequestRemote::requestRemote(CACHE_PATH."status.js",1);
    $status_json = substr($data,10);
    if ((time() > substr($data,0,10)) || !$status_json){
        $server =  $cfg['fc_extendserver'];
        switch ($server){
            case 0:
        	    $status_js = $cfg['fc_api_url'] . "online.js";
        	    if($rs = topcmmRequestRemote::requestRemote($status_js, 1)){
        	        $status_json = substr($rs,11,-1);
        	    }
        	    break;
        	case 1:
        	    $status_js = $cfg['fc_api_url'] . "online.js?group=" . $cfg['fc_group'];
        	    if($rs = topcmmRequestRemote::requestRemote($status_js,1)){
        	        $status_json = substr($rs,11,-1);
        	    }
        	    break;
        	case 2:
        	    $status_js = "http://free.123flashchat.com/freeroomnum.php?roomname=" . $cfg['fc_room'];
        	    if($rs = topcmmRequestRemote::requestRemote($status_js,1)){
                    preg_match("/document.write\('(.*)'\);/",$rs,$matches);
        	        $status['ln'] = $matches[1];
        	        $status['rn'] = '';
        	        $status['cn'] = '';
        	        $status_json = json_encode($status);
        	    }
        	    break;
        }
		@file_put_contents(CACHE_PATH."status.js",(time() + 120) . $status_json);
    }
	return json_decode($status_json,true);
}


function getFcRooms($cfg){
	$opts = array('http'=>array('timeout'=>3,));
	$context = stream_context_create($opts);
	$data = topcmmRequestRemote::requestRemote(CACHE_PATH."rooms.js",1);
	$rooms_json = substr($data,10);
    if ((time() > substr($data,0,10)) || !$rooms_json){
    	$server =  $cfg['fc_extendserver'];
        switch ($server) {
            case 0:
        	    $room_js = $cfg['fc_api_url'] . "rooms.js";
        	    break;
            case 1:
        	    $room_js = $cfg['fc_api_url'] . "rooms.js?group=" . $cfg['fc_group'];
        	    break;
            case 2:
            	break;
        }
        if($rs = topcmmRequestRemote::requestRemote($room_js, 1)){
        	$rooms_json = substr($rs,10,-1);
        }
        @file_put_contents(CACHE_PATH."rooms.js",(time() + 120) . $rooms_json);
    }
    return json_decode($rooms_json, true);
}

function getFcUsers($cfg){
	$opts = array('http'=>array('timeout'=>2,));
	$context = stream_context_create($opts);
	$data =  topcmmRequestRemote::requestRemote(CACHE_PATH."users.js",1);
	$users_json = substr($data,10);
    if ((time() > substr($data,0,10)) || !$users_json){
    	$server =  $cfg['fc_extendserver'];
        switch ($server){
            case 0:
                $rooms = getFcRooms($cfg);
                if ($rooms == null){
                	return null;
                }
                $users = array();
                foreach ($rooms as $room){
                    $user_js = $cfg['fc_api_url'] . "roomonlineusers.js?roomid=" . $room['id'];
                    if($rs = topcmmRequestRemote::requestRemote($user_js, 1)){
                        $users = array_merge($users, json_decode(substr($rs,20,-1),true));
                    }
                }
                $users_json = json_encode($users);
        	    break;
            case 1:
        	    $user_js = $cfg['fc_api_url'] . "roomonlineusers.js?group=" . $cfg['fc_group'];
        	    if($rs = topcmmRequestRemote::requestRemote($user_js, 1)){
        	        $users_json = substr($rs,20,-1);
        	    }
        	    break;
        	case 2:
        		$users = array();
        	    $user_js = "http://free.123flashchat.com/freeroomuser.php?roomname=" . $cfg['fc_room'];
        	    if($rs = topcmmRequestRemote::requestRemote($user_js, 1)){
                        preg_match("/document.write\('(.*)'\);/",$rs,$matches);
    	            foreach (explode(',', $matches[1]) as $user){
    	                $users[] = array('name' => $user);
    	            }
    	        }
    	        $users_json = json_encode($users);
    	        break;
        }
        $users_json = filterUserList($users_json);
        @file_put_contents(CACHE_PATH."users.js",(time() + 120) . $users_json);
    }
    return json_decode($users_json, true);
}

function filterUserList($users_json){
	$user_array =  json_decode($users_json,true);
	$user_regroup_array = array();
	$user_tmp_array = array();
	foreach($user_array as $key => $val){
		if (!in_array($val['name'], $user_tmp_array)){
			$user_tmp_array[] = $val['name'];
			$user_regroup_array[$key] = $user_array[$key];
		}
	}
	return json_encode($user_regroup_array);
}

function getFcCamshow($fc_config){
	$opts = array('http'=>array('timeout'=>3,));
	$context = stream_context_create($opts);
	$data = topcmmRequestRemote::requestRemote(CACHE_PATH."camshow.js",1);
	$camshow_json = substr($data,10);
    if ((time() > substr($data,0,10)) || !$camshow_json){
    	$data = '';
	    if($fc_config['fc_extendserver'] == 2){
			return false;
		}else if($fc_config['fc_extendserver'] == 1){
			$data = topcmmRequestRemote::requestRemote($fc_config['fc_api_url']."camshow.js?group=".$fc_config['fc_group'],1);
		}else{
			$data = topcmmRequestRemote::requestRemote($fc_config['fc_api_url']."camshow.js",1);
		}
		$camshow_json = substr($data,12,-1);
		if(trim($camshow_json) == "Not Found")
		{
			return false;
		}
        @file_put_contents(CACHE_PATH."camshow.js",(time() + 60) . $camshow_json);
    }
    $camshow_arr = json_decode($camshow_json);
    if($camshow_arr){
    	$random_num = rand(0, (count($camshow_arr)-1));
		$camshow_arr[$random_num]->logo = str_replace('../', $fc_config['fc_api_url'], $camshow_arr[$random_num]->logo);
    	return $camshow_arr[$random_num];
    }else{
    	return false;
    }
}

function getFcCamshowList($fc_config){
	global $config;
	$camshows = array();
	$data = topcmmRequestRemote::requestRemote(CACHE_PATH."camshow.js",1);
	$camshow_json = substr($data,10);
    if ((time() > substr($data,0,10)) || !$camshow_json){
	    if($fc_config['fc_extendserver'] == 2){
			$data = '';
		}elseif($fc_config['fc_extendserver'] == 1){
			$data = topcmmRequestRemote::requestRemote($fc_config['fc_api_url']."camshow.js?group=".$fc_config['fc_group'],1);
		}else{
			$data = topcmmRequestRemote::requestRemote($fc_config['fc_api_url']."camshow.js",1);
		}
		$camshow_json = substr($data,12,-1);
        @file_put_contents(CACHE_PATH."camshow.js",(time() + 60) . $camshow_json);
    }
    $camshows = json_decode($camshow_json);
    foreach ($camshows as $key => $value){
    	$camshows[$key]->logo =  str_replace('../', $fc_config['fc_api_url'], $value->logo);
    	$camshows[$key]->url = $config['server'].'/topcmm_123flashchat/123flashchat.php?room='.$value->id;
    }
    return $camshows;
}

function getFcChatUrl($fc_config){
	$url = '';
	switch($fc_config['fc_extendserver']){
		case 0:
			if($fc_config['fc_servertype'] != 1 && $fc_config['fc_clienttype'] == 1){                
				$clientname = '123flashchat.swf';
			}else{
				$clientname = 'htmlchat/123flashchat.html';
			}
			$url =  $fc_config['fc_client_loc'] . $clientname . "?init_host=" . $fc_config['fc_server_host'] . "&init_port=" . $fc_config['fc_server_port'] ;
            $url .= ($fc_config['fc_server_host_s'] ? "&init_host_s=".$fc_config['fc_server_host_s'] : "") . ($fc_config['fc_server_port_s'] ? "&init_port_s=".$fc_config['fc_server_port_s'] : "");
			$url .= ($fc_config['fc_server_host_h'] ? "&init_host_h=".$fc_config['fc_server_host_h'] : "") . ($fc_config['fc_server_port_h'] ? "&init_port_h=".$fc_config['fc_server_port_h'] : "");			
		break;
		case 1:
			if($fc_config['fc_clienttype'] == 1){
				$clientname = '123flashchat.swf';
			}else{
				$clientname = 'htmlchat/123flashchat.html';
			}
			$url = $fc_config['fc_client_loc'] . $clientname . "?init_host=" . $fc_config['fc_server_host'] . "&init_port=" . $fc_config['fc_server_port'];
            $url .= ($fc_config['fc_server_host_s'] ? "&init_host_s=".$fc_config['fc_server_host_s'] : "") . ($fc_config['fc_server_port_s'] ? "&init_port_s=".$fc_config['fc_server_port_s'] : "");
			$url .= ($fc_config['fc_server_host_h'] ? "&init_host_h=".$fc_config['fc_server_host_h'] : "") . ($fc_config['fc_server_port_h'] ? "&init_port_h=".$fc_config['fc_server_port_h'] : "");
			$url .= ($fc_config['fc_extendserver'] == 1) ? ("&init_group=" . $fc_config['fc_group']) : "";
		break;
		case 2:
			$url = "http://free.123flashchat.com/js.php?room=" . urlencode($fc_config['fc_room']) . "&skin="  . $fc_config['fc_client_skin'] . "&lang="  . $fc_config['fc_client_lang'];
		break;
	}
	return $url;
}

function getServerHostPortLocal($client_location){
	$content = topcmmRequestRemote::requestRemote($client_location.'htmlchat/config/config.js',1);
	if ($content){
		//server host
	 	preg_match('/init_host="([a-zA-Z0-9.]*)";/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_host'] = $matches[1];			        	
        }else{
	        preg_match('/init_host = "([a-zA-Z0-9.]*)";/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host'] = $matches[1];			        	
	        }else{
	        	$data['fc_server_host'] = '';
	        }
        }
        //server port
        preg_match('/init_port=([0-9]*);/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_port'] = $matches[1];			        	
        }else{
        	preg_match('/init_port = ([0-9]*);/', $content, $matches);
            if(isset($matches[1])){
            	$data['fc_server_port'] = $matches[1];			        	
            }else{
            	$data['fc_server_port'] = '';
            }
        }
        //server host s
		preg_match('/init_host_s="([a-zA-Z0-9.]*)";/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_host_s'] = $matches[1];			        	
        }else{
	        preg_match('/init_host_s = "([a-zA-Z0-9.]*)";/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host_s'] = $matches[1];			        	
	        }else{
	        	$data['fc_server_host_s'] = '';
	        }
        }
        //server port s
        preg_match('/init_port_s=([0-9]*);/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_port_s'] = $matches[1];			        	
        }else{
        	preg_match('/init_port_s = ([0-9]*);/', $content, $matches);
            if(isset($matches[1])){
            	$data['fc_server_port_s'] = $matches[1];			        	
            }else{
            	$data['fc_server_port_s'] = '';
            }
        }
        //server host h
		preg_match('/init_host_h="([a-zA-Z0-9.]*)";/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_host_h'] = $matches[1];			        	
        }else{
	        preg_match('/init_host_h = "([a-zA-Z0-9.]*)";/', $content, $matches);
	        if(isset($matches[1])){
	        	$data['fc_server_host_h'] = $matches[1];			        	
	        }else{
	        	$data['fc_server_host_h'] = '';
	        }
        }
        //server port h
        preg_match('/init_port_h=([0-9]*);/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_port_h'] = $matches[1];			        	
        }else{
        	preg_match('/init_port_h = ([0-9]*);/', $content, $matches);
            if(isset($matches[1])){
            	$data['fc_server_port_h'] = $matches[1];			        	
            }else{
            	$data['fc_server_port_h'] = '';
            }
        }
        return $data;
    }else{
    	return false;
    }
}

function getServerHostPortHost($client_location){
	$content = topcmmRequestRemote::requestRemote($client_location,1);
	if ($content){
		//server port
		preg_match('/init_port=([0-9]*)/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_port'] = $matches[1];			        	
        }
        //server port s
		preg_match('/init_port_s=([0-9]*)/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_port_s'] = $matches[1];			        	
        }
        //server port h
		preg_match('/init_port_h=([0-9]*)/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_port_h'] = $matches[1];			        	
        }
        //server host
		preg_match('/init_host=([a-zA-Z0-9.]*)/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_host'] = $matches[1];			        	
        }
        //server host s
		preg_match('/init_host_s=([a-zA-Z0-9.]*)/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_host_s'] = $matches[1];			        	
        }
        //server host h
		preg_match('/init_host_h=([a-zA-Z0-9.]*)/', $content, $matches);
        if(isset($matches[1])){
        	$data['fc_server_host_h'] = $matches[1];			        	
        }
        return $data;
    }else{
        return false;
    }
}

?>